local hrwm_name = "HighResWorldMap"
local hrwm_version = "1.5"

local tiles = {
    "Art/maps/tamriel/Tamriel_0.dds",
    "Art/maps/tamriel/Tamriel_1.dds",
    "Art/maps/tamriel/Tamriel_2.dds",
    "Art/maps/tamriel/Tamriel_3.dds",
    "Art/maps/tamriel/Tamriel_4.dds",
    "Art/maps/tamriel/Tamriel_5.dds",
    "Art/maps/tamriel/Tamriel_6.dds",
    "Art/maps/tamriel/Tamriel_7.dds",
    "Art/maps/tamriel/Tamriel_8.dds",
    "Art/maps/tamriel/Tamriel_9.dds",
    "Art/maps/tamriel/Tamriel_10.dds",
    "Art/maps/tamriel/Tamriel_11.dds",
    "Art/maps/tamriel/Tamriel_12.dds",
    "Art/maps/tamriel/Tamriel_13.dds",
    "Art/maps/tamriel/Tamriel_14.dds",
    "Art/maps/tamriel/Tamriel_15.dds",
}

local enabled = true
local spoilers = false -- Set this to true if you want the map containing spoilers by default
local _GetMapTileTexture = GetMapTileTexture
local function hrwm_GetMapTileTexture(index)
    local tex = _GetMapTileTexture(index)
    if not enabled then return tex end
    for i = 1, 16 do
        if tiles[i] == tex then
            ---- Replace certain tiles if you are on live server and have spoilers enabled
            --if GetAPIVersion() == 101033 and not spoilers and (i == 99) then
            --    i = tostring(i) .. "_spoilerfree"  
            --end
            return "HighResWorldMap/tiles/tamriel_" .. i .. ".dds"
        end
    end
    return tex
end

local _GetMapCustomMaxZoom = GetMapCustomMaxZoom
local function hrwm_GetMapCustomMaxZoom()
    if not enabled then return _GetMapCustomMaxZoom() end
    if GetMapName() == "Tamriel" then
        return 12
    else
        return _GetMapCustomMaxZoom()
    end
end

local function OnAddonLoaded(event, addonName)
    if addonName ~= hrwm_name then return end
    EVENT_MANAGER:UnregisterForEvent(hrwm_name, EVENT_ADD_ON_LOADED)

    GetMapTileTexture = hrwm_GetMapTileTexture
    GetMapCustomMaxZoom = hrwm_GetMapCustomMaxZoom
    
    SLASH_COMMANDS["/highresworldmap"] = function() enabled = not enabled end
    --SLASH_COMMANDS["/showmapspoilers"] = function() spoilers = not spoilers end
end

EVENT_MANAGER:RegisterForEvent(hrwm_name, EVENT_ADD_ON_LOADED, OnAddonLoaded)